--- if_run.c.fix2_vnet_plus_radiotap	2013-06-14 10:15:34.890774314 +0200
+++ if_run.c.fix1_vnet	2013-06-14 10:12:49.786774072 +0200
@@ -2536,10 +2536,13 @@
 	m->m_pkthdr.rcvif = ifp;
 	m->m_pkthdr.len = m->m_len = len;
 
-	/*
-	 * DAAN: fill-in tap header BEFORE calling ieee80211_input*() so the
-	 * user will see the actual data that belongs to THIS packet..
-	 */
+	if (ni != NULL) {
+		(void)ieee80211_input(ni, m, rssi, nf);
+		ieee80211_free_node(ni);
+	} else {
+		(void)ieee80211_input_all(ic, m, rssi, nf);
+	}
+
 	if (__predict_false(ieee80211_radiotap_active(ic))) {
 		struct run_rx_radiotap_header *tap = &sc->sc_rxtap;
 
@@ -2576,13 +2579,6 @@
 			break;
 		}
 	}
-
-	if (ni != NULL) {
-		(void)ieee80211_input(ni, m, rssi, nf);
-		ieee80211_free_node(ni);
-	} else {
-		(void)ieee80211_input_all(ic, m, rssi, nf);
-	}
 }
 
 static void
